--[[
    GFZROCK meme (bad)
	
	v1.1
		Courtesy of haya added some new stuff haha
    
    v1.0.5
        Fixed some sounds being unable to be found
    
    v1.0.4
        Changed sound for when a bad sound is given from default to sfx_thok
    
    v1.0.3
        Network syncing
    
    v1.0.2
        Spam protection
        Added arguments for flat, texture, and sound
    
    v1.0.1
        Empty mid texture slots no longer are replaced. Fixed solid midtexture issues.
    
    v1
        Initial
]]

freeslot("sfx_nrfths")

--global var storage. really squeezing out optimizations here
local FF_TRANSLUCENT = FF_TRANSLUCENT
local ML_BLOCKMONSTERS = ML_BLOCKMONSTERS
local ML_EFFECT3 = ML_EFFECT3
local ML_TFERLINE = ML_TFERLINE
local FRACUNIT = FRACUNIT
--this one isn't defined in source YET
local COM_ADMIN = 1

local DEF_FLAT = "GFZFLR01"
local DEF_TEX = R_TextureNumForName("GFZROCK")
local DEF_SKY = 8693 // There's no way to set a sky to a different texture other than sky nums...
local DEF_SND = sfx_nrfths

local GFZSKY_TOGGLE = CV_RegisterVar({
	name = "GFZROCK_SKY",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = {Off = 0, IgnoreSky = 1, ReplaceSky = 2}
})

--define the texture blacklists per linedef type
local lineTypeFrontTopBlacklistArray = {
    4,   --Speed Pad
    9,   --Chain Parameters
    14,  --Bustable Block Parameters
    15,  --Fan Particle Spawner Parameters
    102, --Translucent Solid FOF
    121, --Translucent Water FOF
    123, --Sideless Translucent Water FOF
    124, --Translucent Goo Water FOF
    125, --Sideless Translucent Goo Water FOF
    141, --Intangible-Bottomed Translucent FOF
    142, --Intangible-Bottomed Sideless Translucent FOF
    144, --Intangible-Topped Translucent FOF
    145, --Intangible-Topped Sideless Translucent FOF
    174, --Crumbling Respawning Intangible-Bottomed Translucent FOF
    175, --Crumbling Respawnless Intangible-Bottomed Translucent FOF
    192, --Translucent Solid Rising Platform FOF
    195, --Intangible-Bottomed Translucent Rising Platform FOF
    221, --Intangible Translucent FOF
    253, --Translucent Shatter Block FOF
    256, --Translucent Spin-Bustable Block FOF
    331, --Continuous Player Skin Executor Trigger
    332, --Each-Time Player Skin Executor Trigger
    333, --Once Player Skin Executor Trigger
    334, --Continuous Object Dye Executor Trigger
    335, --Each-Time Object Dye Executor Trigger
    336, --Once Object Dye Executor Trigger
    413, --Change Music
    414, --Play Sound Effect
    425, --Change Object State
    434, --Award Power-Up
    442, --Change Object Type State
    443, --Call Lua Function
    447, --Change Tagged Sector's Colormap
    455, --Fade Tagged Sector's Colormap
    461, --Spawn Object
    463, --Dye Object
    606  --Colormap
}
local lineTypeFrontBottomBlacklistArray = {9, 14, 15, 331, 332, 333, 413, 425, 434, 442, 443, 447,
    455, 461, 606}
local lineTypeFrontMidBlacklistArray = {9, 14, 15, 331, 332, 333, 413, 425, 434, 442, 443, 447, 455,
    461, 606}
local lineTypeBackTopBlacklistArray = {
    9,
    259, --Custom FOF
    442
}
local lineTypeBackBottomBlacklistArray = {9, 442}
local lineTypeBackMidBlacklistArray = {9, 442}

--define the flat blacklists per linedef type
--[[
local lineTypeFrontFloorBlacklistArray = {}
local lineTypeFrontCeilingBlacklistArray = {}
local lineTypeBackFloorBlacklistArray = {}
local lineTypeBackCeilingBlacklistArray = {}
]]

--make the basic lookup tables out of the arrays
local function returnTrue()
    return true
end

local function makeBasicLookupTableFromArray(array)
    local lookup = {}
    for _, value in ipairs(array) do
        lookup[value] = returnTrue
    end
    return lookup
end

local lineTypeFrontTopBlacklist = makeBasicLookupTableFromArray(lineTypeFrontTopBlacklistArray)
local lineTypeFrontBottomBlacklist = makeBasicLookupTableFromArray(lineTypeFrontBottomBlacklistArray)
local lineTypeFrontMidBlacklist = makeBasicLookupTableFromArray(lineTypeFrontMidBlacklistArray)
local lineTypeBackTopBlacklist = makeBasicLookupTableFromArray(lineTypeBackTopBlacklistArray)
local lineTypeBackBottomBlacklist = makeBasicLookupTableFromArray(lineTypeBackBottomBlacklistArray)
local lineTypeBackMidBlacklist = makeBasicLookupTableFromArray(lineTypeBackMidBlacklistArray)

--[[
local lineTypeFrontFloorBlacklist = makeBasicLookupTableFromArray(lineTypeFrontFloorBlacklistArray)
local lineTypeFrontCeilingBlacklist = makeBasicLookupTableFromArray(lineTypeFrontCeilingBlacklistArray)
local lineTypeBackFloorBlacklist = makeBasicLookupTableFromArray(lineTypeBackFloorBlacklistArray)
local lineTypeBackCeilingBlacklist = makeBasicLookupTableFromArray(lineTypeBackCeilingBlacklistArray)
]]

--define special case handlers
local function hasBlockEnemiesLineFlag(line)
    return line.flags & ML_BLOCKMONSTERS
end

local function hasPegMidTextureAndTransferLineLineFlags(line)
    return line.flags & (ML_EFFECT3 | ML_TFERLINE) == ML_EFFECT3 | ML_TFERLINE
end

local function hasTransferLineLineFlag(line)
    return line.flags & ML_TFERLINE
end

--assign special case handles
lineTypeFrontTopBlacklist[259] = function(line)
    local backSide = line.backside
    return backSide and backSide.toptexture & FF_TRANSLUCENT
end

lineTypeBackTopBlacklist[434] = hasBlockEnemiesLineFlag
lineTypeBackBottomBlacklist[434] = hasBlockEnemiesLineFlag
lineTypeBackMidBlacklist[434] = hasBlockEnemiesLineFlag

lineTypeBackTopBlacklist[447] = hasPegMidTextureAndTransferLineLineFlags
lineTypeBackBottomBlacklist[447] = hasPegMidTextureAndTransferLineLineFlags
lineTypeBackMidBlacklist[447] = hasPegMidTextureAndTransferLineLineFlags

lineTypeBackTopBlacklist[455] = hasTransferLineLineFlag
lineTypeBackBottomBlacklist[455] = hasTransferLineLineFlag
lineTypeBackMidBlacklist[455] = hasTransferLineLineFlag

--Control Text Prompt
lineTypeBackTopBlacklist[459] = hasTransferLineLineFlag
lineTypeBackBottomBlacklist[459] = hasTransferLineLineFlag
lineTypeBackMidBlacklist[459] = hasTransferLineLineFlag


local function returnNil() end

local GFZROCK_internal
local tryUnlockGFZROCK_internal = returnNil
local unlockGFZROCK

local function getSoundFromGlobal(name)
    local sound = _G[name:lower()]
    if not sound then
        sound = _G[name:sub(1, 4) .. name:sub(5):upper()]
        if not sound then
            sound = sfx_thok
        end
    end
    return sound
end

local function GFZROCK_accepting(player, flat, texture, sound, sky)
    --spam protection
    GFZROCK_internal = returnNil
    
    if flat == "!" and texture == "!" and sound == "!" then
        COM_BufInsertText(
            player,
            "echo \"Bruh, you really just said to do nothing. Think you're funny, eh?\""
        )
        --spam protection
        tryUnlockGFZROCK_internal = unlockGFZROCK
        return
    end
    
    if flat then
        if flat == "!" then
            flat = nil
        elseif flat:len() > 8 or not flat:match("^[%w_]+$") then
            flat = DEF_FLAT
        end
    else
        flat = DEF_FLAT
    end
    
    if texture then
        if texture == "!" then
            texture = nil
        elseif texture:len() > 8 or not texture:match("^[%w_]+$") then
            texture = DEF_TEX
        else
            texture = R_TextureNumForName($)
        end
    else
        texture = DEF_TEX
    end
    
    if sound then
        if sound == "!" then
            sound = nil
        elseif sound:len() > 10 or not sound:match("^[%w_]+$") then
            sound = DEF_SND
        elseif sound:sub(1, 4) == "sfx_" then
            sound = getSoundFromGlobal(sound)
        elseif sound:len() <= 6 then
            sound = getSoundFromGlobal("sfx_" .. sound)
        else
            sound = DEF_SND
        end
    else
        sound = DEF_SND
    end
	
	if sky then
        if sky == "!" then
            sky = nil
        elseif flat:len() > 4 or not flat:match("^[%w_]+$") then
            sky = DEF_SKY
		elseif tonumber(sky) ~= nil then
			sky = tonumber($)
		else
			sky = DEF_SKY
        end
    else
        sky = DEF_SKY
    end
	
	local skytoggle = (GFZSKY_TOGGLE.value == 2 and sky)
    
    --[[
    local sectorFloorBlacklist = {}
    local sectorCeilingBlacklist = {}
    ]]
    
    if texture then
        for i = 0, #lines - 1 do
            local line = lines[i]
            local lineSpecial = line.special
            
            local frontSide = line.frontside
            if frontSide and frontSide.valid then
                local tFunc = lineTypeFrontTopBlacklist[lineSpecial]
                local bFunc = lineTypeFrontBottomBlacklist[lineSpecial]
                local mFunc = lineTypeFrontMidBlacklist[lineSpecial]
                
                if --[[frontSide.toptexture and]] not (tFunc and tFunc(line)) then
                    frontSide.toptexture = texture
                end
                if --[[frontSide.bottomtexture and]] not (bFunc and bFunc(line)) then
                    frontSide.bottomtexture = texture
                end
                if frontSide.midtexture and not (mFunc and mFunc(line)) then
                    frontSide.midtexture = texture
                end
                
                --[[
                local frontSector = line.frontSector
                local fFunc = lineTypeFrontFloorBlacklist[lineSpecial]
                local cFunc = lineTypeFrontCeilingBlacklist[lineSpecial]
                
                if fFunc and fFunc(line) then
                    sectorFloorBlacklist[frontSector] = true
                end
                if cFunc and cFunc(line) then
                    sectorCeilingBlacklist[frontSector] = true
                end
                ]]
				
				if lineSpecial == 423 and skytoggle then // dont let change sky affect our sky in gfzrock sky mode 2!
					frontSide.textureoffset = sky * FRACUNIT // yes, it needs to be multiplied by fracunit
				end
            end
            
            local backSide = line.backside
            if backSide and backSide.valid then
                local tFunc = lineTypeBackTopBlacklist[lineSpecial]
                local bFunc = lineTypeBackBottomBlacklist[lineSpecial]
                local mFunc = lineTypeBackMidBlacklist[lineSpecial]
                
                if --[[backSide.toptexture and]] not (tFunc and tFunc(line)) then
                    backSide.toptexture = texture
                end
                if --[[backSide.bottomtexture and]] not (bFunc and bFunc(line)) then
                    backSide.bottomtexture = texture
                end
                if backSide.midtexture and not (mFunc and mFunc(line)) then
                    backSide.midtexture = texture
                end
                
                --[[
                local backSector = line.backsector
                local fFunc = lineTypeBackFloorBlacklist[lineSpecial]
                local cFunc = lineTypeBackCeilingBlacklist[lineSpecial]
                
                if fFunc and fFunc(line) then
                    sectorFloorBlacklist[backSector] = true
                end
                if cFunc and cFunc(line) then
                    sectorCeilingBlacklist[backSector] = true
                end
                ]]
            end
        end
    end
    
    if flat then
        for i = 0, #sectors - 1 do
            local sector = sectors[i]
            --if not sectorFloorBlacklist[sector] then
			if not (sector.floorpic == "F_SKY1" and GFZSKY_TOGGLE.value > 0) then
                sector.floorpic = flat
			end
            --end
            --if not sectorCeilingBlacklist[sector] then
			if not (sector.ceilingpic == "F_SKY1" and GFZSKY_TOGGLE.value > 0) then
                sector.ceilingpic = flat
			end
            --end
        end
    end
	
	if skytoggle then
		for p in players.iterate do
			P_SetupLevelSky(sky, p)
		end
	end
    
    if sound then
        --funne
        S_StartSound(nil, sound)
    end
    
    --spam protection
    tryUnlockGFZROCK_internal = unlockGFZROCK
end

function unlockGFZROCK()
    tryUnlockGFZROCK_internal = returnNil
    GFZROCK_internal = GFZROCK_accepting
end

GFZROCK_internal = GFZROCK_accepting

local function syncLocals(network)
    GFZROCK_internal = network(GFZROCK_internal)
    tryUnlockGFZROCK_internal = network(tryUnlockGFZROCK_internal)
end

--Forget making practical mods; this is legit hilarious
local function GFZROCK(player, flat, texture, sound, sky)
    GFZROCK_internal(player, flat, texture, sound, sky)
end

COM_AddCommand("GFZROCK", GFZROCK, COM_ADMIN)

local function tryUnlockGFZROCK()
    tryUnlockGFZROCK_internal()
end

addHook("ThinkFrame", tryUnlockGFZROCK)