rawset(_G, "inertiaplus" , CV_RegisterVar({
	name = "inertiaplus",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

local FRACUNIT = FRACUNIT

local function rescale(value, oldmin, oldmax, newmin, newmax)
    return newmin +  FixedMul(FixedDiv( value-oldmin , oldmax-oldmin), newmax-newmin)
end


local function InertiaPlus(mo)
	if not inertiaplus.value then return end
	if not (mo and mo.valid) then return end
	
	local p = mo.player
	
	p.lastspeedboost = $ or 0
	
	--print("Current boost: "..p.kartstuff[k_speedboost])
	--print("Last Frame boost: "..p.lastspeedboost)
	
	if p.kartstuff[k_speedboost] < p.lastspeedboost then
		--print("Speed Easing activated")
		local oldboost = p.lastspeedboost
		local decay = rescale(p.kartweight*FRACUNIT, FRACUNIT, 9*FRACUNIT, 320*FRACUNIT, 480*FRACUNIT)
		if (oldboost - FixedDiv(FRACUNIT, decay)) <= 0 then
			p.kartstuff[k_speedboost] = 0
		else
			p.kartstuff[k_speedboost] = max($, oldboost - FixedDiv(FRACUNIT, decay))
		end
	end
	
	p.lastspeedboost = p.kartstuff[k_speedboost]
end
addHook("MobjThinker", InertiaPlus, MT_PLAYER)

local function EaseReset(mo)
	if not mo.player then return end
	
	mo.player.lastspeedboost = 0
end
addHook("MobjDeath", EaseReset, MT_PLAYER)