-- Joinblock by Indev for Sunflower's Garden
-- Disables joining for known midjoin desynch maps to provide a better experience
local MAPS = {
	MAP59 = true,
	MAP92 = true,
	MAPA4 = true,
	MAPCW = true,
	MAPDU = true,
	MAPG9 = true,
	MAPHQ = true,
	MAPIZ = true,
	MAPKP = true,
	MAPLS = true,
	MAPM6 = true,
	MAPME = true,
	MAPNM = true,
	MAPPE = true,
	MAPPH = true,
	MAPR1 = true,
	MAPR6 = true,
	MAPRO = true,
	MAPSO = true,
	MAPSQ = true,
	MAPT6 = true,
	MAPTL = true,
	MAPUA = true,
	MAPUN = true,
	MAPUO = true,
	MAPUT = true,
	MAPVV = true,
	MAPXE = true,
	MAPXH = true,
	MAPXS = true,
	MAPYI = true,
}

local joinblock = false

-- i wish these were a thing like leveltime
local intermissiontime = 0
local votetime = 0

local function countPlayers()
    local c = 0

    for player in players.iterate do
        if not player.spectator then
            c = c + 1
        end
    end

    return c
end

local function setJoinAllowed(allow)
    COM_BufInsertText(server, "allowjoin "..(allow and 1 or 0))
end

local function updateJoinblock(var)
    if var.value then
        setJoinAllowed(countPlayers() < 2 or not joinblock)
    else
        setJoinAllowed(true)
    end
end

local cv_joinblock = CV_RegisterVar {
    name = "joinblock",
    defaultvalue = "On",
    PossibleValue = CV_OnOff,
    flags = CV_NETVAR|CV_CALL|CV_NOINIT,
    func = updateJoinblock,
}

addHook("MapLoad", function(mapid)
    joinblock = MAPS[G_BuildMapName(mapid)]
    intermissiontime = 0
    votetime = 0
end)

addHook("ThinkFrame", function()
    if not isserver then return end

    if leveltime == 1 then
        updateJoinblock(cv_joinblock)
    end

    if joinblock and (countPlayers() < 2) then
        joinblock = false
        updateJoinblock(cv_joinblock)
    end
end)

addHook("IntermissionThinker", function()
    if not isserver then return end

    joinblock = false
    intermissiontime = $ + 1

    if intermissiontime == 1 then
        updateJoinblock(cv_joinblock)
    end
end)

addHook("VoteThinker", function()
    if not isserver then return end

    joinblock = false
    votetime = $ + 1

    if votetime == 1 then
        updateJoinblock(cv_joinblock)
    end
end)
