-- Created by Indev for Sunflower's Garden
-- Rewritten by GenericHeroGuy

-- player died, save their item timers
addHook("MobjDeath", function(mo)
	mo.player.keepinvincibility = min(mo.player.kartstuff[k_invincibilitytimer], 10*TICRATE)
	mo.player.keepgrow = min(max(mo.player.kartstuff[k_growshrinktimer], 0), 12*TICRATE) -- don't keep shrink
	if HugeQuest then
		mo.player.keephuge = min(mo.player.hugequest.huge, 12*TICRATE)
		mo.player.keepsparkle = min(mo.player.hugequest.sparkle, 10*TICRATE)
	end
	mo.player.keeprocketsneaker = mo.player.kartstuff[k_rocketsneakertimer]
	mo.player.keepstuff = true
end, MT_PLAYER)

-- restore items when a player respawns
addHook("PlayerSpawn", function(player)
	if player.spectator or (not player.keepstuff) then return end

	-- reset timers so we can restore music properly
	player.kartstuff[k_invincibilitytimer] = player.keepinvincibility
	player.kartstuff[k_growshrinktimer] = player.keepgrow
	if HugeQuest then
		player.hugequest.huge = player.keephuge
		player.hugequest.sparkle = player.keepsparkle
	end

	player.kartstuff[k_rocketsneakertimer] = player.keeprocketsneaker
	P_RestoreMusic(player)

	-- set grow scale
	if player.keepgrow or player.keephuge then
		player.mo.scalespeed = mapobjectscale/TICRATE
		player.mo.destscale = (3*mapobjectscale)/2
	end

	-- spawn rocket sneakers (totally not yoinked from k_kart)
	if player.keeprocketsneaker then
		S_StartSound(player.mo, sfx_s3k3a)
		local prev = player.mo
		for i = 0, 1 do
			local mo = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_ROCKETSNEAKER)
			K_MatchGenericExtraFlags(mo, player.mo)
			mo.flags = $ | MF_NOCLIPTHING
			mo.angle = player.mo.angle
			mo.target = player.mo
			mo.hprev = prev
			prev.hnext = mo
			prev = mo
		end
	end
end)

-- freeze item timers until player lands after respawning
addHook("PlayerThink", function(player)
	if player.keepstuff and not player.deadtimer then
		if player.kartstuff[k_respawn] then
			player.kartstuff[k_invincibilitytimer] = player.keepinvincibility
			player.kartstuff[k_growshrinktimer] = player.keepgrow
			player.kartstuff[k_rocketsneakertimer] = player.keeprocketsneaker
			if HugeQuest then
				player.hugequest.huge = player.keephuge
				player.hugequest.sparkle = player.keepsparkle
			end
		else
			player.keepstuff = false
		end
	end
end)

-- reset on map load
addHook("MapChange", function()
	for player in players.iterate() do
		player.keepstuff = false
	end
end)
