local EncoreInitial = nil
local SpeedInitial = nil
local onBowser = false

-- Returns true if there is a single player ingame
local function singleplayer()
	local n = 0
	for p in players.iterate do
		if p.valid and not p.spectator then
			n = $ + 1
			if n > 1 then
				return false
			end
		end
	end
	return true
end

local function doyoudare(player)
	if not singleplayer() or player.spectator then
		CONS_Printf(player, "How dare you")
		return false
	end
	return true
end

local function initBrowser(player)
	if not doyoudare(player) then return end

	-- TODO: allow in battle
	if mapheaderinfo[gamemap].typeoflevel & TOL_MATCH then
		CONS_Printf(player, "Please exit battle first")
		return
	end

	if not InitBrowser then
		print("Browser is not loaded")
		return
	end
	
	onBowser = true

	InitBrowser()
end
COM_AddCommand("levelselect", initBrowser)

local function getGamer()
	for p in players.iterate do
		if p.valid and not p.spectator then
			return p
		end
	end
end

local function think()
	if not singleplayer() then return end
	
	local p = getGamer()
	
	if p then
		if p.cmd.buttons & BT_CUSTOM2 and p.cmd.buttons & BT_CUSTOM1 then
			onBowser = true
		end
		if not onBowser then return end
		if BrowserController(p) then
			onBowser = false
		end

		-- prevent intermission while browsing
		if p.exiting then
			p.exiting = $ + 1
		end
	end
end
addHook("ThinkFrame", think)

local function toggleEncore(player)
	if not doyoudare(player) then
		return
	end

	local enc = CV_FindVar("kartencore")
	if EncoreInitial == nil then
		EncoreInitial = enc.value
	end

	if enc.value then
		COM_BufInsertText(server, "kartencore off")
	else
		COM_BufInsertText(server, "kartencore on")
	end
end
COM_AddCommand("encore", toggleEncore)

local function toggleHard(player)
	if not doyoudare(player) then
		return
	end

	local enc = CV_FindVar("kartspeed")
	if SpeedInitial == nil then
		SpeedInitial = enc.value
	end

	if enc.value == 2 then
		COM_BufInsertText(server, "kartspeed normal")
	else
		COM_BufInsertText(server, "kartspeed hard")
	end
end
COM_AddCommand("togglehard", toggleHard)

local function changelevel(player, ...)
	if not doyoudare(player) then
		return
	end

	local map = ...
	if map == nil then
		CONS_Printf(player, "Usage: changelevel MAPXX")
		return
	end

	local mapnum = lb_mapnum_from_extended(map)
	if not mapnum then
		CONS_Printf(player, string.format("Invalid map name: %s", map))
	end

	if mapheaderinfo[mapnum] == nil then
		CONS_Printf(player, string.format("Map doesn't exist: %s", map:upper()))
		return
	end

	-- Verify valid race level
	if not (mapheaderinfo[mapnum].typeoflevel & (TOL_SP | TOL_RACE)) then
		CONS_Printf(player, "Battle maps are not supported")
		return
	end

	COM_BufInsertText(server, string.format("map %d", mapnum))
end
COM_AddCommand("changelevel", changelevel)

local function initLeaderboard(player)
	local disable = not ((maptol & (TOL_SP | TOL_RACE)) and singleplayer())

	-- Restore encore mode to initial value
	if disable and EncoreInitial != nil then
		COM_BufInsertText(server, string.format("kartencore %d", EncoreInitial))
		EncoreInitial = nil
	end

	player.afkTime = leveltime
	onBowser = false
end
addHook("PlayerSpawn", initLeaderboard)

local function drawScoreboard(v, player)
	if player != displayplayers[0] then return end
	if onBowser then
		DrawBrowser(v, player)
	end
end
hud.add(drawScoreboard, "game")

addHook("NetVars", function(net)
	EncoreInitial = net($)
	SpeedInitial = net($)
	onBowser = net($)
end)