-- SPBPity by Indev for Sunflower's Garden
-- Gives a small catch up compensation for receiving a SPB, which is essentially useless for you normally.
-- The compensation is based on your position of firing it (1-3 Sneakers or Rocket Sneakers (pos 10+)), or nothing when fired as first.
-- Using the SPB while in 1st will give you some MT, just so it's not 100% useless in Tuesday :3 - Bladesinger
local ROCKETSNEAKER_POSITION = 10

addHook("ThinkFrame", function()
    if leveltime < 2 then return end

    for player in players.iterate do
        if leveltime == 2 then
            player.spbpity = nil
            continue
        end

        if not player.spectator then
            if player.kartstuff[k_itemtype] == KITEM_SPB then
                player.spbpity = true
            elseif player.spbpity and player.kartstuff[k_stolentimer] then
                player.spbpity = false -- No compensation for players whose spb
                                       -- got stolen by hyudoro :P
            elseif player.spbpity then
                if player.kartstuff[k_position] >= ROCKETSNEAKER_POSITION then
                    player.kartstuff[k_itemtype] = KITEM_ROCKETSNEAKER
                    player.kartstuff[k_itemamount] = 1
                    player.kartstuff[k_itemblink] = TICRATE
                    player.kartstuff[k_itemblinkmode] = 2
                    S_StartSound(nil, sfx_itrolk, player)
                else
                    player.kartstuff[k_itemtype] = KITEM_SNEAKER

                    player.kartstuff[k_itemblink] = TICRATE

                    local amount = 0

                    if K_IsPlayerLosing(player) and player.kartstuff[k_position] ~= 2 then
                        amount = 3
                        S_StartSound(nil, sfx_itrolk, player)
                        player.kartstuff[k_itemblinkmode] = 2
                    elseif player.kartstuff[k_position] > 2 then
                        amount = 2
                        S_StartSound(nil, sfx_itrolf, player)
                        player.kartstuff[k_itemblinkmode] = 0
                    elseif player.kartstuff[k_position] == 2 then
                        amount = 1
                        S_StartSound(nil, sfx_itrolm, player)
                        player.kartstuff[k_itemblinkmode] = 1
					else
						player.kartstuff[k_driftboost] = $ + 100
                    end

                    player.kartstuff[k_itemamount] = amount
                end

                player.spbpity = false
            end
        end
    end
end)
