--                _                            _        
--               | |                          | |       
--  __      _____| | ___ ___  _ __ ___   ___  | |_ ___  
--  \ \ /\ / / _ \ |/ __/ _ \| '_ ` _ \ / _ \ | __/ _ \ 
--   \ V  V /  __/ | (_| (_) | | | | | |  __/ | || (_) |
--    \_/\_/ \___|_|\___\___/|_| |_| |_|\___|  \__\___/ 
--                      _                            _     _ 
--                     (_)                          | |   | |
--  __      ____ _ _ __ _  ___   __      _____  _ __| | __| |
--  \ \ /\ / / _` | '__| |/ _ \  \ \ /\ / / _ \| '__| |/ _` |
--   \ V  V / (_| | |  | | (_) |  \ V  V / (_) | |  | | (_| |
--    \_/\_/ \__,_|_|  |_|\___/    \_/\_/ \___/|_|  |_|\__,_|
--
-- At April 1st, an anniversary kart session was made at Karts R Us.
-- We were originally gonna have intro soundbytes for some maps, however
-- that didn't end up happening due to issues with freeslotting sounds.
--
-- Fortunately, I've made a solution to that- here's QuickSoundbytes!
-- Just plop this in your server, use QS_AddSoundbyte and whala!
-- Intro soundbytes for levels that didn't have em!
--
-- - haya, 2022
rawset(_G, "QuickSoundbytes", "1")
print("\142QuickSoundbytes v"..QuickSoundbytes.." has been loaded! Looking for soundbytes next.")

local soundbytes = {}
local muted = false
local function qs_shutup(p, ...)
	p.qs_muted = true
	if p == consoleplayer then
		muted = true
	end
	CONS_Printf(p, "\131OK! \128You won't hear level soundbytes anymore. Try \130qs_webacc\128 if you change your mind.")
end
COM_AddCommand("qs_shutup", qs_shutup)
local function qs_shutup(p, ...)
	p.qs_muted = false
	if p == consoleplayer then
		muted = false
	end
	CONS_Printf(p, "\131OK! \128You will hear level soundbytes again. Welcome back!")
end
COM_AddCommand("qs_webacc", qs_shutup)

local function thinksoundbyte()
	-- only at the start, bitch.
	if leveltime ~= 2 then return end
	if not soundbytes[gamemap] then return end -- we dont have a soundbyte, fuck off
	
	-- get our soundbyte
	local soundbyte = soundbytes[gamemap]
	-- get our params
	local sbname = _G[soundbyte.name]
	local sbchance = soundbyte.chance or 0
	
	-- chance is 0 or less than a random number
	if sbchance == 0 or (P_RandomRange(1, 1000) <= sbchance) then
		for p in players.iterate do
			-- RA EXTENDED SUPER RAINBOW ROAD
			if not (muted or p.qs_muted) then
				S_StartSound(nil, sbname, p)
			end
		end
	end
end

addHook("PostThinkFrame", thinksoundbyte)

local function allocatenewsb(name)
	if not _G[name] then
		freeslot(name)
	else
		print(name .. " already allocated. Will be ignored.")
	end
end

// FROM TOGAUTILS

// Conversion between extended and integer map ID.
// Integer to Extended was easier...
local function INTtoEXT(i)
	local dummy = "dumdumdum"
	if i < 100 then return i end // Return itself if it doesn't have an extended map equivalent.
	if i > 1035 then return end // ...why?
	local x, p, q, a, b
	x = i-100
	p = x/36
	q = (x-(36*p))
	a = dummy.char(p+65)
	if q < 10 then b = q
	else b = dummy.char(q+55) end
	return a..b
end

// ...as this was an adventure of itself to figure out.
local function EXTtoINT(i)
	local dummy = "mudmudmud"
	if i.len(i) != 2 then return end // Do we have an extended map ID without the MAP bit?
	if tonumber(i) != nil and tonumber(i) < 100 then return i end // If the ID is a number... why? Return itself.
	i = tostring(i:lower())
	local x, y, p, q
	local ttable = {}
	for k, v in dummy.gmatch(i, "%w") do
		table.insert(ttable, k)
	end
	x, y = ttable[1], ttable[2]
	if tonumber(x) != nil then return end // Is our first character a number?!
	p = dummy.byte(x)-97
	if tonumber(y) != nil then q = y
	else q = dummy.byte(y)-87 end
	return ((36*p+q)+100)
end

rawset(_G, "QS_AddSoundbyte", function(...) -- expects same format as the soundbyte table up top
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		allocatenewsb(v.name)
		-- string map name
		if type(v.map) == "string" then
			local ext = EXTtoINT(v.map)
			soundbytes[ext] = v
			print("QuickSoundbytes: Added " .. v.name .. " assigned to MAP" .. tostring(INTtoEXT(ext)))
			return
		end
		-- integer map name (ala 1-1035)
		if type(v.map) == "number" then
			soundbytes[v.map] = v
			print("QuickSoundbytes: Added " .. v.name .. " assigned to MAP" .. tostring(INTtoEXT(v.map)))
			return
		end
		-- somehow still not valid, apparently.
		print("QuickSoundbytes: Invalid map number!")
	end
end)