-- [[CONSOLE VARIABLES]]
rawset(_G, "cv_weather_increment", CV_RegisterVar({
    name = "weathermod_increment",
    defaultvalue = 15, --12
    flags = CV_NETVAR,
    PossibleValue = {MIN = 1, MAX = 99}
}))

rawset(_G, "cv_weather_decrement", CV_RegisterVar({
    name = "weathermod_decrement",
    defaultvalue = 15, --12
    flags = CV_NETVAR,
    PossibleValue = {MIN = 1, MAX = 99}
}))

rawset(_G, "cv_weather_maxtime", CV_RegisterVar({
    name = "weathermod_maxtime",
    defaultvalue = 9999, --9999
    flags = CV_NETVAR,
    PossibleValue = {MIN = 1000, MAX = 99999}
}))

rawset(_G, "cv_weather_hellchance", CV_RegisterVar({
    name = "weathermod_hell",
    defaultvalue = 5, --9999
    flags = CV_NETVAR,
    PossibleValue = {MIN = 0, MAX = 100}
}))

rawset(_G, "cv_weathermod", CV_RegisterVar({
    name = "weathermod",
    defaultvalue = 0,
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
}))

rawset(_G, "cv_weathermod_encore", CV_RegisterVar({
    name = "weathermod_encore",
    defaultvalue = 1,
    flags = CV_NETVAR,
    PossibleValue = {Off = 0, On = 1, force=2}
}))

rawset(_G, "cv_weathermod_visible", CV_RegisterVar({
    name = "weathermod_visible",
    defaultvalue = 1,
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
}))

rawset(_G, "cv_weathermod_order", CV_RegisterVar({
    name = "weathermod_order",
    defaultvalue = 0,
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
}))

rawset(_G, "cv_weathermod_keepforced", CV_RegisterVar({
    name = "weathermod_keepforced",
    defaultvalue = 0,
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
}))

rawset(_G, "cv_weathermod_dynamic", CV_RegisterVar({
    name = "weathermod_dynamic",
    defaultvalue = 0,
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
}))

COM_AddCommand("weathermod_force", function(server, pattern)
    --print(pattern)
    local result = nil

    -- server wants a random weather
    if pattern == "random"
     weathermod.current = weathermod.tableselect[P_RandomKey(#weathermod.tableselect) + 1]
     print("picked a random weather");
     weathermod.active = true
     weathermod.timerW = 1
     weathermod.forceActive = true
     weathermod.random = true
    return end

    if (pattern == nil) print("Specify a weather you want to force"); return end

    -- match the name in the list of weathers
    for _,i in pairs(weathermod.weatherlist) do
		result = string.match(string.lower(i.name), string.lower(pattern))
        if result ~= nil result = i break end -- if one name matchs it takes the table
    end
    -- match the name on weatherhell if no result was found
    if result == nil
    for _,i in pairs(weathermod.weatherhell) do
	 	result = string.match(string.lower(i.name), string.lower(pattern))
         if result ~= nil result = i break end -- if one name matchs it takes the table
    end
    end
	--print(result.value)
    if result and mapheaderinfo[gamemap].removeweather and string.match(mapheaderinfo[gamemap].removeweather, string.lower(result.name))
        print("Weather is restricted by the level header")

    elseif result and weathermod.levelbanweather and string.match(weathermod.levelbanweather, string.lower(result.name))
        print("Weather is restricted by the level header")

    elseif cv_weathermod.value == 0
        print("Weathermod is disabled")
         
        
    elseif result ~= nil -- match found, weather will be active
        weathermod.current = result
        weathermod.previous = result
        weathermod.active = true
        weathermod.timerW = 1
        weathermod.forceActive = true
        weathermod.random = false
        print("forced weather to " + weathermod.current.name)

    else -- no match found, aka result is nil
        print("no match found")
        weathermod.active = false
        weathermod.timerW = cv_weather_maxtime.value
        weathermod.forceActive = false
        weathermod.random = false
        -- [Mountain case] renable hidden hud elements
        hud.enable("item")
    end
end, 1)

COM_AddCommand("weathermod_toggle", function(server, pattern)
    --print(pattern)
    local result = nil

    if (pattern == nil) print("Specify a weather you want to toggle"); return end

    -- match the name in the list of weathers
    for _,i in pairs(weathermod.weatherlist) do
		result = string.match(string.lower(i.name), string.lower(pattern))
        if result ~= nil result = i break end -- if one name matchs it takes the table
    end

	--print(result.value)
    if result ~= nil -- match found, toggle weather
        if (result.toggle == true) weathermod.weatherlist[result.id].toggle = false; print( result.name + " has been toggled \x85OFF")
        else weathermod.weatherlist[result.id].toggle = true; print( result.name + " has been toggled \x83ON")
        end

    else -- no match found, aka result is nil
        print("no match found")
    end
end, 1)


--[[VARIABLES]]
rawset(_G, "weathermod", {
    
    timerW = 0,
    active = false,
    forceActive = false,
    levelbanweather = nil,

    current = nil,
    previous = nil,
    random = false,
    tableselect = {},
   
    weatherlist = {
        {id = 1,  toggle = true, name = "Sunny", color = 101, centerX = 16, desc = "Higher top speed", encore = "EVEN higher top speed"},
        {id = 2,  toggle = true, name = "Snowy", color = 126, centerX = 17, desc = "Slippery track", encore = "Ice skating time"},
        {id = 3,  toggle = true, name = "Earthquake", color = 116, centerX = 30, desc = "Bouncy items", encore = "Higher bouncing item"},
        {id = 4,  toggle = true, name = "Lunar", color = 121, centerX = 17, desc = "Low gravity", encore = "No gravity on items", nobattle = true},
        {id = 5,  toggle = true, name = "Dimension", color = 136, centerX = 26, desc = "Players are bigger", encore = "Players are HUGE"},
        {id = 6,  toggle = true, name = "Typhoon", color = 121, centerX = 22, desc = "Immune to hazards", encore = "No flashtics", nobattle = true},
        {id = 7,  toggle = true, name = "Windy", color = 136, centerX = 16, desc = "Air time charges boost", encore = "Air time charges MORE boost"},
        {id = 8,  toggle = true, name = "Sunset", color = 106, centerX = 19, desc = "Drifting gives boost", encore = "Real gamer drifting"},
        {id = 9,  toggle = true, name = "Twinkle star", color = 101, centerX = 36, desc = "Double item pickups", encore = "Triple item pickups"},
        {id = 10, toggle = true,  name = "Rain", color = 121, centerX = 14, desc = "Lose item/powerup on hit", encore = "Gain item on hit", nobattle = true},
        {id = 11, toggle = true,  name = "Tempest", color = 131, centerX = 22, desc = "Jumping spinout", encore = "Jumping bumps"},
        {id = 12, toggle = true,  name = "Thunderstorm", color = 121, centerX = 38, desc = "Thundershock on spinout", encore = "Gain thunder shield anytime"},
        {id = 13, toggle = true,  name = "Blood moon", color = 116, centerX = 29, desc = "Wipe out racers on bump", encore = "Steal items on bump"},
        {id = 14, toggle = true,  name = "Mountain vapor", color = 131, centerX = 45, desc = "Hidden item slot", encore = "Use quickly your item"},
        {id = 15, toggle = true,  name = "Sandstorm", color = 106, centerX = 26, desc = "Faster drift sparks", encore = "No drift sparks"},
        {id = 16, toggle = true,  name = "Cloudy", color = 136, centerX = 19, desc = "Single item type", encore = "Rare item only"},
        {id = 17, toggle = true,  name = "Blue sky", color = 126, centerX = 22, desc = "Boosts are strange", encore = "Strange driving"},
        {id = 18, toggle = true,  name = "Aurora", color = 106, centerX = 19, desc = "Grant boost from hits", encore = "Grant invincibility from hits"},
        {id = 19, toggle = true,  name = "Night", color = 121, centerX = 17, desc = "Screen is darker", encore = "Can you see somthing?"},
        {id = 20, toggle = true,  name = "Pressure", color = 131, centerX = 25, desc = "The fastest squashs", encore = "Items can squash"},
        {id = 21, toggle = true,  name = "Hail", color = 126, centerX = 13, desc = "Things fall from sky", encore = "MANY things fall from sky"},
        {id = 22, toggle = true,  name = "Comet", color = 101, centerX = 17, desc = "Bigger items", encore = "More bigger items"},
    },

    weatherhell = {
        --{id = 90,  name = "clear", color = 22, centerX = 16, desc = "Nothing happens", encore = "Nothing happens"},
        {id = 91,  name = "Shrink", color = 22, centerX = 18, desc = "Synch Failure", encore = "Synch Failure"},
        {id = 92,  name = "Toy kingdom", color = 22, centerX = 34, desc = "Boing! Boing! Boing!", encore = "Boing! Boing! Boing!"},
        {id = 93,  name = "Parallel Universe", color = 22, centerX = 46, desc = "Drift presses become A presses", encore = "Drift presses become A presses"},
        {id = 94,  name = "Sink rain", color = 22, centerX = 24, desc = "It's danmaku time!", encore = "It's danmaku time!"},
        {id = 95,  name = "Disaster", color = 22, centerX = 24, desc = "Everything is random", encore = "Everything is random"},
        {id = 96,  name = "Superstar", color = 22, centerX = 26, desc = "Go fast", encore = "Go fast"},
    },

    delay = 0,
    lasttime = 0,
    changecount = 0,

    Cloudychooseitem = nil,
    Disasterpick = {weather = nil, effect = nil},

})